# [[file:deploying.org::*Container build with \[\[file:../cce_nixos_core.org\]\[Nix\]\]][Container build with [[file:../cce_nixos_core.org][Nix]]:4]]
with import <nixpkgs> {};

let 
  httpPort = "4000";
  arcology = import ./default.nix {
    src = builtins.fetchGit {
      url = "https://code.rix.si/rrix/arcology.git";
      ref = "nix-docker-checkpoint";
      rev = "0a0d4b8cbbb4e53d175c8cae2e9301fdf2a90628";
    };
    version = "0.1.0";
  };
  installDebugTools = true;
in
dockerTools.buildImage {
  name = "arcology";
  contents = [ arcology ] ++ 
               pkgs.lib.lists.optional installDebugTools [
               pkgs.vim
               pkgs.file
               pkgs.strace
               pkgs.dcfldd
             ];
  created = "now";
  tag = "latest";
  config = {
    Cmd = [ "/opt/arcology/bin/arcology" "start" ];
    Env = [
      ("PATH=${pkgs.coreutils}/bin/"
       + ":${pkgs.bashInteractive}/bin/"
       + ":${pkgs.gnugrep}/bin/"
       + ":${pkgs.gnused}/bin/"
       + ":${pkgs.gawk}/bin/"
       + ":${pkgs.emacs}/bin/"
       + ":${pkgs.pandoc}/bin/"
       + ":${pkgs.strace}/bin/"
       + ":${pkgs.file}/bin/")
      "SHELL=${pkgs.bash}/bin/bash"
      "ARCOLOGY_DIRECTORY=/org"
      "ORG_ROAM_SOURCE=/org-roam"
      "ARCOLOGY_DATABASE=/arcology.db"
      "ARCOLOGY_PORT=${httpPort}"
    ];
    ExposedPorts = {
      "${httpPort}/tcp" = {};
    };
    Volumes = {
      "/org" = {};
      "/arcology.db" = {};
      "/org-roam" = {};
    };
  };
}
# Container build with [[file:../cce_nixos_core.org][Nix]]:4 ends here
